#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <bluetooth/bluetooth.h>
#include <bluetooth/rfcomm.h>
#include <fcntl.h>
#include <termios.h>

int send() {
    // 送信先のBluetoothデバイスのアドレス
    char* server_address = "ここにBluetoothデバイスのアドレスを入力";

    // 通信用ソケットを作成
    int sock = socket(AF_BLUETOOTH, SOCK_STREAM, BTPROTO_RFCOMM);
    struct sockaddr_rc addr = {0};
    addr.rc_family = AF_BLUETOOTH;
    addr.rc_channel = (uint8_t)1;  // 通常はRFCOMMチャネル1を使用

    str2ba(server_address, &addr.rc_bdaddr);

    // 送信するデータ
    uint8_t send_data[1] = 1;        //0でoff, 1でon

    // 送信先のBluetoothデバイスに接続
    if (connect(sock, (struct sockaddr*)&addr, sizeof(addr)) < 0) {
        perror("Bluetooth接続エラー");
        return 1;
    }

    // データを送信
    if (send(sock, data_to_send, sizeof(data_to_send), 0) < 0) {
        perror("データ送信エラー");
    }

    // ソケットを閉じる
    close(sock);

    return 0;
}

int recieve() {
    int fd;
    struct termios options;

    // ESP32との通信に使用するBluetoothシリアルポートのパス
    const char* device_path = "/dev/rfcomm0";

    fd = open(device_path, O_RDWR | O_NOCTTY);

    if (fd == -1) {
        perror("Failed to open the Bluetooth device");
        exit(1);
    }

    tcgetattr(fd, &options);
    cfsetispeed(&options, B9600);  // ボーレートの設定
    cfsetospeed(&options, B9600);
    tcsetattr(fd, TCSANOW, &options);

    uint8_t receive_data[1];
    ssize_t bytesRead = read(fd, receive_data, sizeof(receiveBuffer));
    if (bytesRead > 0) {
        receive_data[bytesRead] = '\0';  // 文字列を終端する
        printf("Received from ESP32: %s\n", receive_data);
        // 受信したデータを処理するコードをここに追加
        if(receive_data == 3){
            //エラー通知
    }

    close(fd);

    return 0;
}
