#include <stdio.h> 
#include <stdint.h>
#include <unistd.h>
#include "arduino.h" 
#include "io.h" 
#include "request.h" 
#include "uss.h" 
#include "direction.h"
#include "com_ESP32.h"

#define MAX 2000
#define sp_time 3

int main(){
	double volt;
	if(io_open() != 0) return -1;
	if(arduino_open() != 0) return -1;
	if(uss_open_l() != 0) return -1;
	if(uss_open_r() != 0) return -1;
	request_set_runmode(STR,0,0);
        usleep(500*1000);
	request_get_batt(&volt);
        printf("Current battery %f v\n",volt);
	while(1){
		request_set_vac(1);		//吸引機起動
		sleep(1);	
		wir(2);
		sleep(sp_time);
		wir(0);
		sleep(sp_time);
		request_set_runmode(ROT,20,45);
		sleep(sp_time);
		wir(1);
		sleep(sp_time);
		wir(0);
		sleep(sp_time);
		request_set_vac(2);	
		sleep(10);
		request_set_vac(1);		//吸引機起動
		sleep(1);	
		wir(2);
		sleep(sp_time);
		wir(0);
		sleep(sp_time);
		request_set_runmode(ROT,20,-45);
		sleep(sp_time);
		wir(1);
		sleep(sp_time);
		wir(0);
		sleep(sp_time);
		request_set_vac(2);	
		sleep(5);
	}
	return 0;
}
