

#include <stdio.h> 
#include <stdint.h>
#include <unistd.h>
#include "arduino.h" 
#include "io.h" 
#include "request.h" 
#include "uss.h" 
#include "direction.h"
#include "com_ESP32.h"

#define MAX 2000
#define sp_time 7

int get_dis();
void run_ctl(int);
int get_dis(){		//進行距離の保存
	int dis[2]={};
	int cur=1;
	int past=0;
	int b=0;
	request_get_dist(&dis[0],&dis[1]);
	cur = dis[0];
	if(cur == 0){
		b = past;
	}else if(cur >= past){
		b = cur;
	}else{
		b = 0;
	}
	past = cur;
	return b;
}

void run_ctl(int dis){	//単位はcm
	int i=0;
	int mode = 0;
	int distance = 0;
	int dist[2]={};
	long uss=0;
	int sw[3] = {};
	run_state_t state;
	state = STR;
	int speed,di;
	request_set_runmode(STR,10,dis);
	while(i < dis){
		while(state != STP){
			uss = get_dist_uss(0);
			printf("uss=%lo\n",uss);
			io_get_sw(sw,&sw[1],&sw[2]);
			distance = get_dis();
			printf("dis = %d\n",distance);
			if(uss < 90 || sw[0] == 0){
				i += distance;
				usleep(10*1000);
				printf("cur[i] = %d\n",i);
				request_set_runmode(STP,0,0);
				mode = 1;
				sleep(2);
                		request_set_runmode(STR,10,-30);
				i -= 30;
		                sleep(5);
				uss = get_dist_uss(0);
				while(uss < 90){
					uss = get_dist_uss(0);
					if(uss == -1)uss=100;
					usleep(200000);
				}
				break;
			}
			request_get_runmode(&state,&speed,&di);
			usleep(300000);
		}
		if(mode == 0){
			printf("stop\n");
			request_get_dist(&dist[0],&dist[1]);
			i += (dist[0]+dist[1])/2;
		}else{
			mode = 0;
			request_set_runmode(STR,30, dis - i);
		}
	}
}

int main(){
	/*int mode = 0;
	int distance = 0;
	int dist[2]={};
	long uss=0;
	int sw[3] = {};*/
	double volt;
	if(io_open() != 0) return -1;
	if(arduino_open() != 0) return -1;
	if(uss_open_l() != 0) return -1;
	if(uss_open_r() != 0) return -1;
	/*run_state_t state;
	state = STR;
	int speed,dis;*/
	printf("press enter to start\n");
	getchar();
	request_set_runmode(STR,0,0);
    usleep(500*1000);
	request_get_batt(&volt);
	request_get_batt(&volt);
    printf("Current battery %f v\n",volt);
	while(1){
		sleep(3);
		//request_set_air(1);		//起動
		sleep(3);
		wir(1);		//ワイヤー展開
		sleep(3);
		//wir(3);
		//sleep(10);
		request_set_runmode(ROT,20,-90);
		sleep(8);	
		request_set_vac(1);	
		sleep(1);
		wir(4);
		sleep(10);
		run_ctl(85);			
		sleep(6);
		request_set_vac(0);
		sleep(1);
		//wir(3);	
		sleep(2);
		/*request_set_runmode(ROT,20,90);
		sleep(8);
		request_set_runmode(STR,15,1);
		sleep(3);
		request_set_runmode(ROT,20,-90);
		sleep(8);*/
		request_set_vac(1);	
		sleep(1);
		//wir(4);
		sleep(1);
		request_set_runmode(STR,15,-85);
		//sleep(37);
		sleep(8);
		request_set_vac(0);		//吸引機停止
		sleep(sp_time);
		request_set_runmode(ROT,20,90);
		sleep(8);	
		wir(2);
		sleep(3);
		/*request_set_runmode(ROT,20,180);
		sleep(sp_time*2);
		direction_correct(40);		//初期位置で整対補正
		direction_correct(40);
		sleep(sp_time);
		request_set_runmode(ROT,20,180);*/
		//sleep(sp_time*2);
		break;
	}
	request_set_air(2);	//空気清浄機停止
	arduino_close();
	return 0;
}
